__UNICODE__ equ 1
.586
.model flat,stdcall
option  casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
ConvertToHex    PROTO   :DWORD
Count_Drives    PROTO

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\shell32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\shell32.lib

include \masm32\macros\macros.asm

.const  
MainWindowWidth     equ     600
MainWindowHeight    equ     400
MAXPATH             equ     256

.data
hInstance       HINSTANCE       ?
hMainWindow     HWND            ?
UCSTR           MainWindowClass, "MainWindowClass",0
UCSTR           MainWindowName,  "Standard Window",0
wcex            WNDCLASSEX      <sizeof wcex,CS_HREDRAW+CS_VREDRAW,offset WndProc,\
                                0,0,?,?,?,COLOR_WINDOW,0,offset MainWindowClass,?>

; +++ ListView related ++++

hListView       HWND        ?
UCSTR           ListViewClass,"SysListView32",0
lvc             LV_COLUMN   <LVCF_WIDTH+LVCF_TEXT,0,?,?,?,0>
lvi             LV_ITEM     <>

; ++++ Strings  ++++

UCSTR           szDrive,"Drive",0
UCSTR           szVolumeName,"Volume Name",0
UCSTR           szSerialNo,"Serial No.",0
UCSTR           szFileSystem,"File System",0

; ++++ Volume related ++++

Drives          dw      MAXPATH dup(0)
VolumeName      dw      MAXPATH dup(0)
SerialNumber    dd      	?
FileFlags       dd      	?
FileSystem      dw      MAXPATH dup(0)
shfi            SHFILEINFO	    <>

; ++++ Other ++++

rect            RECT        <>
iccx            INITCOMMONCONTROLSEX    <sizeof iccx,ICC_LISTVIEW_CLASSES>
NumBuffer       db          20 dup(0)  
StartUp         dd          TRUE       
xlat_table      db          '0123456789ABCDEF'
.code
    start:
        invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  WinMain,hInstance,0,0,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInst
    pop     wcex.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wcex.hIcon,eax
    mov     wcex.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wcex.hCursor,eax
    invoke  RegisterClassEx,addr wcex
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_OVERLAPPEDWINDOW,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,SW_SHOWNORMAL
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop                        
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if     uMsg==WM_CREATE
        mov     edi,lParam
        .if     [edi.CREATESTRUCT].hWndParent==0
            invoke  GetClientRect,hWnd,addr rect
            invoke  CreateWindowEx,WS_EX_STATICEDGE,addr ListViewClass,0,\
                        WS_VISIBLE+WS_CHILD+LVS_REPORT,\
                        0,0,rect.right,rect.bottom,hWnd,0,hInstance,0
            mov     hListView,eax
            mov     eax,rect.right
            shr     eax,2
            mov     lvc.lx,eax
            mov     lvc.pszText,offset szDrive
            invoke  SendMessage,hListView,LVM_INSERTCOLUMN,0,addr lvc
            mov     lvc.pszText,offset szVolumeName
            invoke  SendMessage,hListView,LVM_INSERTCOLUMN,1,addr lvc
            mov     lvc.pszText,offset szSerialNo                                                                                                           
            invoke  SendMessage,hListView,LVM_INSERTCOLUMN,2,addr lvc
            mov     lvc.pszText,offset szFileSystem
            invoke  SendMessage,hListView,LVM_INSERTCOLUMN,3,addr lvc
            
; +++++ Second Stage / Fill ListView +++++

            invoke  GetLogicalDriveStrings,sizeof Drives,addr Drives
            lea     esi,Drives
            call    Count_Drives
            cld
            mov     lvi.iItem,0
            mov     lvi.iSubItem,0
loop_1:
            push    ecx
            invoke  GetVolumeInformation,esi,addr VolumeName,sizeof VolumeName,addr SerialNumber,MAXPATH,addr FileFlags,addr FileSystem,sizeof FileSystem
            mov     lvi.imask,LVIF_IMAGE+LVIF_TEXT
            mov     lvi.pszText,esi
            invoke  SHGetFileInfo,esi,0,addr shfi,sizeof shfi,SHGFI_SYSICONINDEX+SHGFI_SMALLICON
            .if     StartUp==TRUE
                invoke  SendMessage,hListView,LVM_SETIMAGELIST,LVSIL_SMALL,eax
                mov     StartUp,FALSE
            .endif
            push    shfi.iIcon
            pop     lvi.iImage
            invoke  SendMessage,hListView,LVM_INSERTITEM,0,addr lvi
            xor     lvi.imask,LVIF_IMAGE
            inc     lvi.iSubItem
            mov     lvi.pszText,offset VolumeName
            invoke  SendMessage,hListView,LVM_SETITEM,0,addr lvi
            invoke  ConvertToHex,SerialNumber
            mov     lvi.pszText,offset NumBuffer
            inc     lvi.iSubItem
            invoke  SendMessage,hListView,LVM_SETITEM,0,addr lvi
            inc     lvi.iSubItem
            mov     lvi.pszText,offset FileSystem
            invoke  SendMessage,hListView,LVM_SETITEM,0,addr lvi
            mov     lvi.iSubItem,0
            pop     ecx
            dec     ecx
            jcxz    end_loop_1
align_loop:
            lodsw
            or      al,al
            jnz     align_loop            
            jmp     loop_1
end_loop_1:
                                                                    
        .endif
    .elseif uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor     eax,eax
    ret

WndProc     endp                                                

ConvertToHex    PROC    Serial:DWORD

    mov     eax,Serial
    mov     ecx,8
    lea     ebx,xlat_table
    lea     edi,NumBuffer
    cld
loop_1:
    rol     eax,4
    push    eax
    and     eax,1111b
    mov     al,[ebx+eax]
    stosw
    pop     eax
    dec     ecx
    jcxz    end_loop_1
    jmp     loop_1
end_loop_1:
    xor     ah,ah
    mov     al,'h'
    stosw
    mov     al,0
    stosw
    ret

ConvertToHex    endp

Count_Drives    PROC

    push    esi
    lea     esi,Drives
    mov     ecx,0
loop_1:
    lodsb
    or      al,al
    jnz     loop_1
    inc     ecx
    push    esi
    lodsb
    or      al,al
    jz      no_more_drives        
    pop     esi
    jmp     loop_1                 
no_more_drives:
    add     esp,4
    pop     esi
    ret

Count_Drives    endp

end start